<?php
/*
Plugin Name: Multiple Category Selection Widget
Plugin URI: http://www.zackdesign.biz/
Description: Select multiple categories at once using this widget!
Author: Isaac Rowntree
Version: 1.1
Author URI: http://zackdesign.biz

	Copyright (c) 2005, 2006 Isaac Rowntree (http://zackdesign.biz)
	QuickShop is released under the GNU General Public
	License (GPL) http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org).

*/

$wpmm_cats = 0;
$wpmm_search_vars = 0;

function wpmm_load_category()
{
    if (!empty($_POST['wpmm']))
    {        
        $cats = $_POST['wpmm'];
        
        $sql = '';
        foreach ($cats as $cat)
        {
            if ($cat == 0)
                unset($cats[$count]);
            else
                $sql .= $cat.',';
        }
        $sql = trim ($sql, ',');
        if ($sql != '')
        {
          if (get_option('permalink_structure')!= '')
          {
              wp_redirect(get_bloginfo('url').'/categories/'.$sql.'/search_type/'.$_POST['mmctype']);
		          exit();
		      }
		      else
		      {
              wp_redirect(get_bloginfo('url').'/?categories='.$sql.'&search_type='.$_POST['mmctype']);
		          exit();
          }
		    }
    }
    
   global $wp_rewrite;
   $wp_rewrite->flush_rules();
}

function widget_wpmm($args)
{
    extract($args);    
    global $wpdb;
    global $wpmm_cats;
    global $wpmm_search_vars;
                                   
    $categories = get_categories('orderby=name&hide_empty=1&exclude=1');
    
    $parents = array();
    $children = array();
    
    foreach ($categories as $cat)
    {
        if (!$cat->parent)
            $parents[] = $cat;
        else
            $children[] = $cat;
    }
    
    echo $before_widget;
    echo $before_title . 'Categories' . $after_title .'
    
    <form action="" method="post" id="wpmm">
    
    ';
    
    foreach ($parents as $p)
    {
        echo '
        <select name="wpmm[]">
        <option value="0">'.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $p->name))).'</option>';
        
        foreach ($children as $c)
        {
            $selected = '';
            
            if (!empty($wpmm_cats))
            {
                $cats = explode(',', $wpmm_cats);
                
                foreach ($cats as $cat)
                {
                    if ($cat == $c->cat_ID)
                        $selected = 'selected="selected"';
                }
            }
            
            if ($p->cat_ID == $c->parent)
                echo '<option '.$selected.' value="'.$c->cat_ID.'"> '.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $c->name))).'</option>';
        }
        
        echo '</select>';
    }
    
    $checked1 = '';
    $checked2 = '';
    
    if ($wpmm_search_vars == 'and')
        $checked2 = 'checked="checked"';
    else if ($wpmm_search_vars == 'in')
        $checked1 = 'checked="checked"';
    else
        $checked2 = 'checked="checked"';
        
    echo '<br />Any <input type="radio" name="mmctype" value="in" '.$checked1.'> All <input type="radio" name="mmctype" value="and" '.$checked2.'>
    <input type="submit" value="Search"></form>'.$after_widget;
}

function wpmm_widgets()
{

    register_sidebar_widget('Multi-Category', 'widget_wpmm');
}

function categories_queryvars( $qvars )
{
  $qvars[] = 'categories';
  $qvars[] = 'search_type';
  return $qvars;
}

function wpmm_parse($vars)
{
    $cats = explode(',',$vars->query_vars['categories']);

    if (!empty($vars->query_vars['categories']))
    {
        query_posts(array('category__'.$vars->query_vars['search_type'] => $cats, 'paged' => $vars->query_vars['paged']));
    }
    
    global $wpmm_cats;
    global $wpmm_search_vars;
    
    $wpmm_cats = $vars->query_vars['categories'];
    $wpmm_search_vars = $vars->query_vars['search_type'];
}

function wpmm_add_rewrite_rules( $wp_rewrite ) 
{
  $new_rules = array( 
     'categories/(.+)/search_type/(.+)/page/(.+)' => 'index.php?categories=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2).'&paged='. $wp_rewrite->preg_index(3),
     'categories/(.+)/search_type/(.+)' => 'index.php?categories=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2));
  
  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}

// Get Wordpress to parse URL for query categories
add_filter('query_vars', 'categories_queryvars' );

// Run the category selection
add_action('parse_request','wpmm_parse');

// Rewrite URL
add_action('init','wpmm_load_category');
add_action('generate_rewrite_rules', 'wpmm_add_rewrite_rules');

add_action('plugins_loaded', 'wpmm_widgets');

?>